<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/MediaPlayer/AndroidSLESMediaPlayer/include/AndroidSLESMediaPlayer/FFmpegAttachmentInputController.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_9d34932954f3d83257e5e12e3f421a72.html">MediaPlayer</a></li><li class="navelem"><a class="el" href="dir_b97c8a12362aabf73b92afdea21f65db.html">AndroidSLESMediaPlayer</a></li><li class="navelem"><a class="el" href="dir_7b5c7f5aa6c9c2118e08133913118a4b.html">include</a></li><li class="navelem"><a class="el" href="dir_1c7bd630be78b850d01adb3bbc48faf9.html">AndroidSLESMediaPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">FFmpegAttachmentInputController.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_f_fmpeg_attachment_input_controller_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_MEDIAPLAYER_ANDROIDSLESMEDIAPLAYER_INCLUDE_ANDROIDSLESMEDIAPLAYER_FFMPEGATTACHMENTINPUTCONTROLLER_H_</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_MEDIAPLAYER_ANDROIDSLESMEDIAPLAYER_INCLUDE_ANDROIDSLESMEDIAPLAYER_FFMPEGATTACHMENTINPUTCONTROLLER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_attachment_reader_8h.html">AVSCommon/AVS/Attachment/AttachmentReader.h</a>&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_audio_format_8h.html">AVSCommon/Utils/AudioFormat.h</a>&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_f_fmpeg_input_controller_interface_8h.html">AndroidSLESMediaPlayer/FFmpegInputControllerInterface.h</a>&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">struct </span>AVIOContext;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">struct </span>AVInputFormat;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">struct </span>AVDictionary;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>mediaPlayer {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span>android {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html">   38</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html">FFmpegAttachmentInputController</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html">FFmpegInputControllerInterface</a> {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">static</span> std::unique_ptr&lt;FFmpegAttachmentInputController&gt; <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a2873cbacecf02d949723068d9a807839">create</a>(</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentReader&gt; reader,</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">avsCommon::utils::AudioFormat</a>* format = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a3b6033b2271bcae8308567d087fdba39">hasNext</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a97d0d9d7492b962d5f3a08e919754720">next</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    std::tuple&lt;Result, std::shared_ptr&lt;AVFormatContext&gt;, std::chrono::milliseconds&gt; <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#afe2ac9540601b8d5e8ad9aaf78c4f6f5">getCurrentFormatContext</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a52991f5bbe15e1128e33fc11c3091174">~FFmpegAttachmentInputController</a>();</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html">FFmpegAttachmentInputController</a>(</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentReader&gt; reader,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        std::shared_ptr&lt;AVInputFormat&gt; inputFormat = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        std::shared_ptr&lt;AVDictionary&gt; inputOptions = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">int</span> read(uint8_t* buffer, <span class="keywordtype">int</span> bufferSize);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> feedBuffer(<span class="keywordtype">void</span>* userData, uint8_t* buffer, <span class="keywordtype">int</span> bufferSize);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentReader&gt; m_reader;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    std::shared_ptr&lt;AVInputFormat&gt; m_inputFormat;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    std::shared_ptr&lt;AVDictionary&gt; m_inputOptions;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    std::shared_ptr&lt;AVIOContext&gt; m_ioContext;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;};</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;}  <span class="comment">// namespace android</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;}  <span class="comment">// namespace mediaPlayer</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_MEDIAPLAYER_ANDROIDSLESMEDIAPLAYER_INCLUDE_ANDROIDSLESMEDIAPLAYER_FFMPEGATTACHMENTINPUTCONTROLLER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_input_controller_interface.html">alexaClientSDK::mediaPlayer::android::FFmpegInputControllerInterface</a></div><div class="ttdef"><b>Definition:</b> FFmpegInputControllerInterface.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller_html_a2873cbacecf02d949723068d9a807839"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a2873cbacecf02d949723068d9a807839">alexaClientSDK::mediaPlayer::android::FFmpegAttachmentInputController::create</a></div><div class="ttdeci">static std::unique_ptr&lt; FFmpegAttachmentInputController &gt; create(std::shared_ptr&lt; avsCommon::avs::attachment::AttachmentReader &gt; reader, const avsCommon::utils::AudioFormat *format=nullptr)</div><div class="ttdef"><b>Definition:</b> FFmpegAttachmentInputController.cpp:60</div></div>
<div class="ttc" id="_attachment_reader_8h_html"><div class="ttname"><a href="_attachment_reader_8h.html">AttachmentReader.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller_html_a97d0d9d7492b962d5f3a08e919754720"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a97d0d9d7492b962d5f3a08e919754720">alexaClientSDK::mediaPlayer::android::FFmpegAttachmentInputController::next</a></div><div class="ttdeci">bool next() override</div><div class="ttdef"><b>Definition:</b> FFmpegAttachmentInputController.cpp:137</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html">alexaClientSDK::mediaPlayer::android::FFmpegAttachmentInputController</a></div><div class="ttdef"><b>Definition:</b> FFmpegAttachmentInputController.h:38</div></div>
<div class="ttc" id="_f_fmpeg_input_controller_interface_8h_html"><div class="ttname"><a href="_f_fmpeg_input_controller_interface_8h.html">FFmpegInputControllerInterface.h</a></div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">alexaClientSDK::avsCommon::utils::AudioFormat</a></div><div class="ttdef"><b>Definition:</b> AudioFormat.h:31</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller_html_afe2ac9540601b8d5e8ad9aaf78c4f6f5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#afe2ac9540601b8d5e8ad9aaf78c4f6f5">alexaClientSDK::mediaPlayer::android::FFmpegAttachmentInputController::getCurrentFormatContext</a></div><div class="ttdeci">std::tuple&lt; Result, std::shared_ptr&lt; AVFormatContext &gt;, std::chrono::milliseconds &gt; getCurrentFormatContext() override</div><div class="ttdef"><b>Definition:</b> FFmpegAttachmentInputController.cpp:161</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller_html_a52991f5bbe15e1128e33fc11c3091174"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a52991f5bbe15e1128e33fc11c3091174">alexaClientSDK::mediaPlayer::android::FFmpegAttachmentInputController::~FFmpegAttachmentInputController</a></div><div class="ttdeci">~FFmpegAttachmentInputController()</div><div class="ttdef"><b>Definition:</b> FFmpegAttachmentInputController.cpp:213</div></div>
<div class="ttc" id="_audio_format_8h_html"><div class="ttname"><a href="_audio_format_8h.html">AudioFormat.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller_html_a3b6033b2271bcae8308567d087fdba39"><div class="ttname"><a href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_f_fmpeg_attachment_input_controller.html#a3b6033b2271bcae8308567d087fdba39">alexaClientSDK::mediaPlayer::android::FFmpegAttachmentInputController::hasNext</a></div><div class="ttdeci">bool hasNext() const override</div><div class="ttdef"><b>Definition:</b> FFmpegAttachmentInputController.cpp:133</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
